from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class ConfigFeatureFlagsMigration(MigrationABC):
    name = "1.1.0_ConfigFeatureFlagsMigration"

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        MigrationABC.__init__(self)
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, "Running upgrade")

        self._cursor.execute(
            str("""ALTER TABLE CFG_Technician ADD FeatureFlags JSON NULL DEFAULT ('{}') AFTER CacheMaxMessages;""")
        )

        self._cursor.execute(
            str("""ALTER TABLE CFG_Server ADD FeatureFlags JSON NULL DEFAULT ('{}') AFTER LoginMessageChannelId;""")
        )

    def downgrade(self):
        self._logger.debug(__name__, "Running downgrade")
        self._cursor.execute("ALTER TABLE CFG_Technician DROP COLUMN FeatureFlags;")
        self._cursor.execute("ALTER TABLE CFG_Server DROP COLUMN FeatureFlags;")
