from datetime import datetime

from cpl_core.database import TableABC


class ServerAFKChannelIdsConfig(TableABC):
    def __init__(
        self,
        channel_id: int,
        server_id: int,
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._channel_id = channel_id
        self._server_id = server_id

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def channel_id(self) -> int:
        return self._channel_id

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
                SELECT * FROM `CFG_ServerAFKChannelIds`;
            """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `CFG_ServerAFKChannelIds`
                WHERE `Id` = {id};
            """
        )

    @staticmethod
    def get_select_by_server_id_string(server_id: int) -> str:
        return str(
            f"""
                SELECT * FROM `CFG_ServerAFKChannelIds`
                WHERE `ServerId` = {server_id};
            """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
                INSERT INTO `CFG_ServerAFKChannelIds` (
                    `ChannelId`,
                    `ServerId`
                ) VALUES (
                    {self._channel_id},
                    {self._server_id}
                );
            """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
                UPDATE `CFG_ServerAFKChannelIds`
                SET `ChannelId` = {self._channel_id},
                `ServerId` = {self._server_id}
                WHERE `Id` = {self._id};
            """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
                DELETE FROM `CFG_ServerAFKChannelIds`
                WHERE `ChannelId` = {self._channel_id};
            """
        )
